package fi.jyu.mit.ohj2;
/**
 * Alkeellinen IO-luokka hoitamaan mm. yhden näppäimen painallukseen
 * liittyviä tehtäviä.
 *
 * @author Vesa Lappalainen
 * @version 1.0, 10.02.2003
 */
public class  IO {

  /**
   * Luetaan yksi käyttäjän painama merkki
   * @return käyttäjän painama merkki
   */
  public static char lue_merkki() {  
//    String s = Syotto.lue("");
//    if ( s.length() == 0 ) return 0;
//    return s.charAt(0);
    return Readkey.getChar();
  }

  /**
   *  Rivinvaihto
   */
  public static final String RIVINVAIHTO = "\r\n";
  
  /**
   * Ei käytetä oletusarvoa
   */
  public static final char EI_OLETUSTA = 0;
  
  /**
   * Kaikki merkit kelpaavat
   */
  public static final String KAIKKI_KELPAA = null;
  
  /**
   * Muutetaan merkit isoiksi ennen vertailua ja palautusta
   */
  public static final boolean MERKKI_ISOKSI = true;


  /**
   * Odotetaan yhden merkin painamista.  Vain jonossa kelpaavat olevat
   * hyväksytään.  Jos painetaan [Enter], palautetaan merkki oletus.
   * Jos merkki_isoksi == true, muutetaan merkki ennen vertailua ja palautusta
   * isoksi kirjaimeksi.
   * Esim.  <pre>c = odota_nappain("KE",'K',MERKKI_ISOKSI)</pre>
   * odottaa kunnes painetaan joko K,k,E,e tai [Enter].   Jos painetaan
   * [Enter], palautetaan 'K', muuten ko. painettu merkki.
   *
   * @param kelpaavat Joukko kirjaimia jotka kelpaavat. null = kaikki kelpaa
   * @param oletus Merkki joka palautetaan [Enter] painamisesta, 0 = ei oltusta
   * @param merkki_isoksi muutetaanko merkki isoksi kirjaimeksi (true) vai ei
   * @return käyttäjän painama merkki, joko joukosta kelpaavat tai sitten oletus
   */
  public static char odota_nappain(String kelpaavat, char oletus,  
                                   boolean merkki_isoksi) {  
    char painettu;
    do {
      painettu = lue_merkki();
      if ( merkki_isoksi ) painettu = Character.toUpperCase(painettu);
      if ( oletus != EI_OLETUSTA && RIVINVAIHTO.indexOf(painettu) >= 0 )
        return oletus;
    } while ( kelpaavat != null && kelpaavat.indexOf(painettu) < 0 );
    return painettu;
  }


  /**
   * Odotetaan kunnes käyttäjä painaa jotakin merkkiä
   */
  public static void odota_jotakin()   {  
    System.out.println("Paina jotakin!");
    odota_nappain(KAIKKI_KELPAA,EI_OLETUSTA,MERKKI_ISOKSI);
  }


  /**
   * Odotetaan kunnes käyttäjä painaa joko K tai E
   * @return true jos käyttäjä painaa K, muuten false
   */
  public static boolean kylla_vastaus()   {
    return (odota_nappain("KE",'K',MERKKI_ISOKSI)=='K');
  }

  
  /**
   * Testataan syöttöluokkaa
   * @param args ei käytössä
   */
  public static void main(String[] args) {
     String kelpaavat = "ABCDE";
     System.out.print("Paina joku kirjaimista " + kelpaavat + " (F) :");
     char c = odota_nappain(kelpaavat,'F',MERKKI_ISOKSI);
     System.out.println();
     System.out.println("Painoit " + c);
     odota_jotakin();
  }
}

